#include <amxmodx>
#include <reapi>

#define FLAG ADMIN_BAN

public plugin_init()
{
	register_plugin("Team menu", "1.1", "NobodyInTeam");

	register_dictionary("teammenu.txt");

	RegisterHookChain(RG_ShowVGUIMenu, "ShowVGUIMenu", 0);
	RegisterHookChain(RG_HandleMenu_ChooseTeam, "HandleMenu_ChooseTeamPre", 0);
	RegisterHookChain(RG_HandleMenu_ChooseTeam, "HandleMenu_ChooseTeamPost", 1);
}

public ShowVGUIMenu(const id, VGUIMenu:menuType, const bitsSlots, szOldMenu[]) {
    if (is_user_bot(id) || menuType != VGUI_Menu_Team) {
        return HC_CONTINUE;
    }
    
    set_member(id, m_bForceShowMenu, true);

    new bool:newPlayer = bool:(TeamName:get_member(id, m_iTeam) == TEAM_UNASSIGNED);
    
    new keys = MENU_KEY_1;

    new menu[512];
    new len = formatex(menu, charsmax(menu), "\w%L^n^n", id, "SELECT_TEAM");
    if (newPlayer) {
        len += formatex(menu[len], charsmax(menu) - len, "\d[\r1\d] \r%L^n", id, "ENTER_GAME");
    } else {
        len += formatex(menu[len], charsmax(menu) - len, "\d[\r1\d] \r%L^n", id, "CHANGE_TEAM");
    }

    if (!newPlayer || (get_user_flags(id) & FLAG)) {
        len += formatex(menu[len], charsmax(menu) - len, "\d[\r6\d] \w%L^n", id, "SPECTATOR");
        keys |= MENU_KEY_6;
    }

    if (!newPlayer) {
        len += formatex(menu[len], charsmax(menu) - len, "^n^n\d[\r0\d] \w%L^n", id, "CLOSE");
        keys |= MENU_KEY_0;
    }

    SetHookChainArg(3, ATYPE_INTEGER, keys);
    SetHookChainArg(4, ATYPE_STRING, menu);
    
    return HC_CONTINUE;
}

public HandleMenu_ChooseTeamPre(const id, const MenuChooseTeam:slot) {
    if (is_user_bot(id)) {
        return HC_CONTINUE;
    }
    switch (slot) {
        case MenuChoose_T: {
            SetHookChainArg(2, ATYPE_INTEGER, getNewTeam(id));
        }
        
        case MenuChoose_Spec: {
            if (is_user_alive(id)) {
                user_silentkill(id);
            }
        }
    }

    return HC_CONTINUE;
}

public HandleMenu_ChooseTeamPost(const id) {
    set_member(id, m_bTeamChanged, false);
}

MenuChooseTeam:getNewTeam(id) {
    switch (TeamName:get_member(id, m_iTeam)) {
        case TEAM_TERRORIST: {
            return MenuChoose_CT;
        }

        case TEAM_CT: {
            return MenuChoose_T;
        }
    }

    return MenuChoose_AutoSelect;
}